/** Code to fire on page load */
jQuery(document).ready(function() {

	/* Search Box: on/off focus */
	var search_input = jQuery("#travelSubnav #searchField");
	var search_txt = search_input.val();
    search_input.focus(function() { obj = this; inputFocus(obj, search_txt); });
   	search_input.blur(function() { obj = this; inputBlur  (obj, search_txt); });


	/* Toggle featured image photo caption onclick */
	jQuery(".tFeatureImgFt .imgCaption").click ( function() {
		jQuery("#contentWellMain .tFeatureImgCaption").slideToggle("slow");
		return false; // Stops any default action
	});

	jQuery("#travelBranding div.travelMastheadLeft").click(function(){
	    // some partner chromes from '10 launch were not updated and need this
	    window.location.href = "http://travel.usatoday.com/index";
	});
	
	jQuery("body#travelTheme ul#community-nav li.active").next().css("background","none");
	if (jQuery.browser.webkit && jQuery(".travelBoxLede").length > 0){
	    jQuery(".travelBoxLede .formatSpace").css("position","static");
	}
	
	/* Removing right margin on items in slim item blocks */
	var tItemArr = jQuery("body#travelTheme .tSlim .tItem:not(.wide)");	
	for (i=0;i<tItemArr.length;i++) {
		if (i%2!=0){ jQuery(tItemArr[i]).css("margin-right","0px"); }
	}

	/* Share Bar */
	if (jQuery(".tShareBarCont").length > 0 && jQuery(".fArticleItem").length < 1)
		buildShareBarLinks();
		
	/* Toggle "more" share options */
	jQuery(".tShareBarCont .tShareBar li a.sMore").click ( function() {
		if(jQuery(this).hasClass("sLess")) {
			jQuery(this).removeClass("sLess").html("More");
		} else {
			jQuery(this).addClass("sLess").html("Less");
		}
	
		jQuery(this).parents(".tShareBar").find(".sMoreList").slideToggle("slow");
		
		return false; // Stops any default action
	});
	
	/* guides pages */
	if(jQuery.browser.webkit && jQuery('#guideTabs').length > 0){
	    jQuery('#guideTabs li').css({'padding-bottom':'2px'});
	}
	if(typeof submitSearch == 'function'){
        jQuery("#search").after('<input type="submit" value="" style="display:none" />');
        jQuery("#searchForm").submit(function(){
            return false; // prevent submit handler, current code only works on anchor click
        });
    }
    
    if(jQuery("#morePhotoGalleries").length > 0){
        var c = 1;
        jQuery("#morePhotoGalleries li a").each(function(){
            jQuery(this).attr("id", c);
            c++;
        });
        var pName = jQuery("#morePhotoGalleries").attr("class");
        jQuery("#morePhotoGalleries li a").click(function(){
            var num = jQuery(this).attr("id");
            s_objectID = pName + '|morephotogalleries|pack|' + num;
        });
    }
    
    if(jQuery('#contentWellRight .sectionArchiveList').length > 0){
        loadListSplitter();
  	    jQuery('#contentWellRight .sectionArchiveList').easyListSplitter();
  	}

}); /** END document on ready */


/** Utility Functions */

// replace missing image with appropriate fallback image onError
function handleImageError(img, path, large) {
	if (large) {
		file = "/images/photo_missing_lg.jpg";
	}
	else {
		file = "/images/photo_missing_thumb.jpg";
	}
	
	if (path.match(/destinations/i)) {
		path = "destinations";
	}
	else if(path.match(/flights/i)) {
		path = "flights";
	}
	else if (path.match(/cruises/i)) {
		path = "cruises";
	}
	else if (path.match(/hotels/i)) {
		path = "hotels";
	}
	else if (path.match(/deals/i)) {
		path = "deals";
	}
	else if (path.match(/experts/i)) {
		path = "experts";
	}
	else {
		path = "index";
	}
	
    img.src = 'http://i.usatoday.net/travel/_common/' + path + file;
}

// Sets text input val to '' on focus if current value equals val
function inputFocus(obj,val) {
	return (jQuery(obj).val() == val) ? jQuery(obj).val('') : false;
}

// Sets text input val to specficied 'val' on focus
function inputBlur (obj, val){
	return (jQuery(obj).val() == '') ? jQuery(obj).val(val) : false;
}

function buildShareBarLinks () {
	// Getting URL and page title
	var storyURL        = document.location.href;
	var storyTitle      = document.title;
	
	// Building Links for individual share links
	var yBuzzURL        = "http://buzz.yahoo.com/buzz?publisherurn=usatoday&guid="+storyURL+"?csp=34";
	var mixxURL         = "http://mixx.com/submit/story?page_url="+storyURL+"partner=usat";
	var facebookURL     = "http://www.facebook.com/sharer.php?u="+storyURL+"&title="+storyTitle;
	var twitterURL      = "http://twitter.com/home?status=RT @USATODAY "+storyTitle+" "+storyURL;;
	var farkURL         = "http://cgi.fark.com/cgi/fark/farkit.pl?u="+storyURL+"&h="+storyTitle;
	var redditURL       = "http://reddit.com/submit?url="+storyURL+"&title="+storyTitle;
	var diggURL         = "http://digg.com/submit?phase=2&url="+storyURL+"title="+storyTitle;
	var myspaceURL      = "http://www.myspace.com/index.cfm?fuseaction=postto&u="+storyURL+"&t="+storyTitle;
	var stumbleuponURL  = "http://www.stumbleupon.com/submit?url="+storyURL+"&h="+storyTitle;
	var propellerURL    = "http://www.propeller.com/story/submit/?url="+storyURL+"&title="+storyTitle;
	var linkedinURL     = "http://www.linkedin.com/shareArticle?mini=true&url="+storyURL+"&title="+storyTitle+"&source=USATODAY.com";
	
	// Attaching href's to specific links
	var sBar = jQuery(".tShareBar");
	
	sBar.find(".sYBuzz").attr("href",yBuzzURL);
	sBar.find(".sMixx").attr("href",mixxURL);
	sBar.find(".sFacebook").attr("href",facebookURL);		
	sBar.find(".sTwitter").attr("href",twitterURL);
	sBar.find(".sFark").attr("href",farkURL);
	sBar.find(".sReddit").attr("href",redditURL);
	sBar.find(".sDigg").attr("href",diggURL);
	sBar.find(".sMyspace").attr("href",myspaceURL);
	sBar.find(".sStumbleUpon").attr("href",stumbleuponURL);
	sBar.find(".sPropeller").attr("href",propellerURL);
	sBar.find(".sLinkedIn").attr("href",linkedinURL);
}

function loadListSplitter(){
    var j = 1;
    (function(jQuery) {
        jQuery.fn.easyListSplitter = function(options) { 	
            var defaults = {			
	            colNumber: 2,
	            direction: 'vertical'
            };
            this.each(function() {    		
	            var obj = jQuery(this);
	            var settings = jQuery.extend(defaults, options);
	            var totalListElements = jQuery(this).find('li').size();
	            var baseColItems = Math.ceil(totalListElements / settings.colNumber);
	            var listClass = jQuery(this).attr('class');    		    		
	            for (i=1;i<=settings.colNumber;i++)
	            {	
		            if(i==1){
			            jQuery(this).addClass('listCol1').wrap('<div class="listContainer'+j+'"></div>');
		            } else if(jQuery(this).is('ul')){
			            jQuery(this).parents('.listContainer'+j).append('<ul class="listCol'+i+'"></ul>');
		            } else{
			            jQuery(this).parents('.listContainer'+j).append('<ol class="listCol'+i+'"></ol>');
		            }
			            jQuery('.listContainer'+j+' > ul,.listContainer'+j+' > ol').addClass(listClass);
	            }    		
	            var listItem = 0;
	            var k = 1;
	            var l = 0;	   		
	            if(settings.direction == 'vertical'){     			
		            jQuery(this).find('li').each(function(){
			            listItem = listItem+1;
			            if (listItem > baseColItems*(settings.colNumber-1) ){
				            jQuery(this).parents('.listContainer'+j).find('.listCol'+settings.colNumber).append(this);
			            } 
			            else {
				            if(listItem<=(baseColItems*k)){
					            jQuery(this).parents('.listContainer'+j).find('.listCol'+k).append(this);
				            } 
				            else{
					            jQuery(this).parents('.listContainer'+j).find('.listCol'+(k+1)).append(this);
					            k = k+1;
				            }
			            }
		            });    			
		            jQuery('.listContainer'+j).find('ol,ul').each(function(){
			            if(jQuery(this).children().size() == 0) {
			            jQuery(this).remove();
			            }
		            });	    			
	            } else{ 			
		            jQuery(this).find('li').each(function(){
			            l = l+1;
			            if(l <= settings.colNumber){
				            jQuery(this).parents('.listContainer'+j).find('.listCol'+l).append(this);   					
			            } else {
				            l = 1;
				            jQuery(this).parents('.listContainer'+j).find('.listCol'+l).append(this);
			            }				
		            });
	            }  		
	            jQuery('.listContainer'+j).find('ol:last,ul:last').addClass('last');	
	            j = j+1;
            });
        };
    })(jQuery);
}

/** END Utility Functions */